"use server";

import { prisma } from "@/prisma/prismaClient";
import { redirect } from "next/navigation";

export const createSchema = async (form: FormData) => {
  const name = form.get("name")?.toString();
  const gsId = form.get("gsId")?.toString();

  if (!name || !gsId) return;

  const { id } = await prisma.schema.create({
    data: {
      name,
      schema: "{}",
      types: "{}",
      version: 0,
      gameSystemId: gsId,
    },
    select: { id: true },
  });
  redirect(`/game-systems/${gsId}/schema/${id}`);
};
